Last Comment Bug 736608 - On some linux systems webrtc fails to link due to not finding XML_* functions from expat
: On some linux systems webrtc fails to link due to not finding XML_* functions...
Status: RESOLVED FIXED
[qa-]
:
Product: Core
Classification: Components
Component: WebRTC (show other bugs)
: Trunk
: All Linux
: -- normal (vote)
: ---
Assigned To: Nobody; OK to take it and work on it
:
Mentors:
Depends on:
Blocks: 688178
  Show dependency treegraph
 
Reported: 2012-03-16 14:32 PDT by Randell Jesup [:jesup]
Modified: 2012-07-27 10:32 PDT (History)
4 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
hack to paper over the external expat problem by building it internal (2.25 KB, patch)
2012-03-16 14:33 PDT, Randell Jesup [:jesup]
rjesup: feedback+
Details | Diff | Splinter Review
Temp hack - Use system expat on Mac but not linux (1.36 KB, patch)
2012-03-16 20:30 PDT, Randell Jesup [:jesup]
no flags Details | Diff | Splinter Review
Temp hack (fixed) - Use system expat on Mac but not linux (1.20 KB, patch)
2012-03-17 00:46 PDT, Randell Jesup [:jesup]
no flags Details | Diff | Splinter Review
Fix for this linkage problem (1.95 KB, patch)
2012-04-18 13:08 PDT, Eric Rescorla (:ekr)
rjesup: feedback+
Details | Diff | Splinter Review

Description Randell Jesup [:jesup] 2012-03-16 14:32:18 PDT
This is references from libjingle, which uses 'normal' expat (char, not PR_UniChar).
Fails on builders and on Ethan's Ubuntu 11.10, not on Fedora 15x64

Probably a side-effect of the SipCC checkin or maybe Bas's

libjingle tries to use system expat on linux, but instead ends up looking for an internal link symbol.  May be an include-path issue at the heart.
Comment 1 Randell Jesup [:jesup] 2012-03-16 14:33:09 PDT
Created attachment 606739 [details] [diff] [review]
hack to paper over the external expat problem by building it internal
Comment 2 Randell Jesup [:jesup] 2012-03-16 14:49:53 PDT
Comment on attachment 606739 [details] [diff] [review]
hack to paper over the external expat problem by building it internal

Note: this patch is not for eventual checkin to mozilla-central; the include issue that causes the base problem should be solved, and this bug kept open until then
Comment 3 Ethan Hugg [:ehugg] 2012-03-16 15:11:12 PDT
Comment on attachment 606739 [details] [diff] [review]
hack to paper over the external expat problem by building it internal

Review of attachment 606739 [details] [diff] [review]:
-----------------------------------------------------------------

This fixes the problem where it breaks on Ubuntu64 but succeeds on Fedora15.  Building expat internally reduces risk of build platform variability.  The only downside I see is a marginally longer build time.
Comment 4 Randell Jesup [:jesup] 2012-03-16 15:30:52 PDT
hack checked in as https://hg.mozilla.org/projects/alder/rev/10a5f0e2bc71
Comment 5 Randell Jesup [:jesup] 2012-03-16 20:30:13 PDT
Created attachment 606831 [details] [diff] [review]
Temp hack - Use system expat on Mac but not linux
Comment 6 Randell Jesup [:jesup] 2012-03-16 20:33:09 PDT
Attachment 606831 [details] [diff] - Partial backout of previous patch - re-enable system expat on Mac

https://hg.mozilla.org/projects/alder/rev/41d5c11a453f
Comment 7 Randell Jesup [:jesup] 2012-03-17 00:46:25 PDT
Created attachment 606841 [details] [diff] [review]
Temp hack (fixed) - Use system expat on Mac but not linux
Comment 8 Eric Rescorla (:ekr) 2012-04-18 13:08:50 PDT
Created attachment 616262 [details] [diff] [review]
Fix for this linkage problem

We really don't want to use the system lib on Mac, but we get collisions with the existing expat. The following patch munges the unmunged symbols on the existing expat so that doesn't happen and then uses the libjingle/third_party expat.
Comment 9 Randell Jesup [:jesup] 2012-04-18 14:41:44 PDT
Comment on attachment 616262 [details] [diff] [review]
Fix for this linkage problem

f+ with mods to fold expat back into the main list of libs (and remove the now-spurious comment)
Comment 10 Eric Rescorla (:ekr) 2012-04-20 07:39:52 PDT
Checked in with nits as: http://hg.mozilla.org/projects/alder/rev/70cddbbd129b

Note You need to log in before you can comment on or make changes to this bug.